#  Copyright (c) 2006 Six Feet Up, Inc.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

from Products.Archetypes import public as atapi
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore import utils as cmf_utils
from Products.CMFCore.DirectoryView import registerDirectory
import Products.PromoEngine.config

# Register the skins directory
registerDirectory(config.SKINS_DIR, config.GLOBALS)

def initialize(context):
    # Importing the content types allows for their registration
    # with the Archetypes runtime
    import content
    import tools

    # Ask Archetypes to handback all the type information needed
    # to make the CMF happy.
    types = atapi.listTypes(config.PROJECTNAME)
    content_types, constructors, ftis = \
        atapi.process_types( types, config.PROJECTNAME)
        
    tools=[tools.admanager.AdManager, tools.adcatalog.AdCatalog]
    cmf_utils.ToolInit( config.PROJECTNAME+' Tools',
                tools = tools,
                icon='tool.gif'
                ).initialize( context )

    cmf_utils.ContentInit(
        '%s Content' % config.PROJECTNAME,
        content_types = content_types,
        permission =
        CMFCorePermissions.AddPortalContent,
        extra_constructors = constructors,
        fti = ftis,
        ).initialize(context)
