import random
import sys

from ZTUtils import LazyFilter
from zope.interface import implements

from Products.CMFCore.utils import getToolByName
from Products.CMFPlone import utils
from Products.PromoEngine.browser.interfaces import IAdFetcher

_marker = []

class AdFetcher(utils.BrowserView):
    implements(IAdFetcher)
    
    def getAd(self, object=False, slot=None, template=None, ad_types=['Ad']):
        """Retrieve an ad from the ad manager
        """
        context = utils.context(self)
        catalog_tool = getToolByName(context, 'ad_catalog')
        prop_tool = getToolByName(context, 'portal_properties')
        ad_states = prop_tool.promo_engine_properties.ad_states
        ads = []
        unique_objects = []
        unique_slots = []
        
        # get the ads based on the object's references
        if object:
            # try and except in case the object doesn't support references
            try:
                raw_object_ads = object.getBRefs('AdLocation')
                object_ads = LazyFilter(raw_object_ads, skip='View')
                # ads of a given type
                filtered_ads = [obj for obj in object_ads \
                    if obj.portal_type in ad_types]
                wf_tool = getToolByName(context, 'portal_workflow')
                # get ads of workflow states defined in the properties
                published_object_ads = [obj for obj in filtered_ads \
                    if wf_tool.getInfoFor(obj,'review_state',None) in ad_states]
                unique_objects = [item.UID() for item in published_object_ads]
            except AttributeError:
                # if the object doesn't support refs then set object to none
                # so we can still use slots on that object
                object = None
        
        # get the ads based the slot wanted
        if slot:
            query = {'portal_type':ad_types,
                     'getAdSlot':slot,
                     'review_state':ad_states}
            slot_ads = catalog_tool.searchResults(query)
            unique_slots = [item.UID for item in slot_ads]
        
        # see if there is a call for a slot and an object and get the
        # unique results.  Otherwise get the unique_slots or unique_objects
        if object is not False and slot:
            # Check to see if the context given is None
            if object is not None:
                ads = [item for item in unique_objects if item in unique_slots]
            else:
                # we had no context. return empty.
                ads = []
        elif slot:
            ads = unique_slots
        elif object:
            ads = unique_objects
            
        # if there are ads then choose one and then get the object
        if ads:
            uidtool = getToolByName(context, 'uid_catalog')
            # TODO: could optionaly use some 80/20 type functionality here
            ad_uid = random.choice(ads)
            query = {'UID':ad_uid}
            ad_brains = uidtool(query)
            for brain in ad_brains:
                ad_obj = brain.getObject()
        # otherwise return and empty macro
        else:
            ad_obj = None
            macro = template.pt_macros()['empty']
            return macro

        # look for the context in the stack
        frame = sys._getframe()
        try:
            econtext = _marker
            while econtext is _marker and frame is not None:
                econtext = frame.f_locals.get('econtext', _marker)
                frame = frame.f_back
            if econtext is _marker:
                raise RuntimeError, 'Context not found'
        finally:
            del frame
            
        econtext.setLocal('ad', ad_obj)
        macro = template.pt_macros()['view']
        return macro
