#  Copyright (c) 2006 Six Feet Up, Inc.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""
The Ad Manager that takes care of showing and storing ads
"""
from AccessControl import ClassSecurityInfo

from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFCore.utils import UniqueObject
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import atapi
from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.content.folder import ATFolderSchema

from Products.PromoEngine.config import PROJECTNAME

ATFolderSchemaCopy = ATFolderSchema.copy()
ATFolderSchemaCopy['id'].widget.visible = {'view' : 'hidden', 'edit' : 'hidden'}

AdManagerSchema = ATFolderSchemaCopy + atapi.Schema((
    atapi.LinesField(
        'slots',
        default=['Select a slot',
                 'Slot 1',
                 'Slot 2',
                 'Slot 3'
                 ],
        widget=atapi.LinesWidget(
            label='Slots for ads',
            description="""Set up the list of slots for the ads.  If you add
                slots then you will need to add a new portlet and modify the
                slot call.""",
            ),
    ),
#    atapi.LinesField(
#        'adLocations',
#        vocabulary = 'getTypesList',
#        widget=atapi.MultiSelectionWidget(
#            label='Allowed ad locations',
#            description="""Select the types that will be allowed to be set
#                as references for ads""",
#        ),
#    ),
))

class AdManager(ATFolder,UniqueObject):
    """Used to manage ads
    """
    security = ClassSecurityInfo()
    archetype_name = portal_type = meta_type = 'Ad Manager'
    allowed_content_types = ['Ad Folder']
    suppl_views    = ('folder_summary_view',
                      'folder_tabular_view',
                      'folder_listing')
    content_icon   = 'billboard_icon.gif'

    schema = AdManagerSchema
    
    def __init__(self, *args, **kwargs):
        ATFolder.__init__(self, 'ad_manager')
        
    # tool should not appear in portal_catalog (borrowed from AGX output)
    def at_post_edit_script(self):
        self.unindexObject()
        
    #def getTypesList(self):
    #    ttool = getToolByName(self, 'portal_types')
    #    types_list = [(item, item) for item in ttool.objectIds()]
    #    return atapi.DisplayList(types_list)

atapi.registerType(AdManager, PROJECTNAME)
